<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\NewCode;
use Teknisa\SM\Util\Utilities;


class SmPercentualMaximoDescontoAcrescimoOperadorController extends SMCrud {
    
    protected $dataSourceName = "fct_percdescoper_widget";
    protected $newCode;
    protected $utilities;
    
    public function __construct($crudService, $environment, NewCode $newCode, Utilities $utilities) {
        parent::__construct($crudService, $environment);
        $this->newCode = $newCode;
        $this->utilities = $utilities;
    }
   
   /**
    *  Função que salva cada registros do cadastramento automático depois que valida se é permitido no banco
    */
    
     public function saveCadastramentoAutomatico(Request\Row $request, Response $response){
         try {
             $row = $request->getRow();
             $TipoException = array();
            
            if($row["IDTIPODESC"] && $row["VRPERCDESCDESC"] && $row["NRPARCNEGOCIODESC"] && $row["CDSERVORCADESC"]){
                $idtipo = $row["IDTIPODESC"];
                $vrpercdesc = $row["VRPERCDESCDESC"];
                $parceiros = $row["NRPARCNEGOCIODESC"];
                $servicos = $row["CDSERVORCADESC"];
                
                $validacao = $this->gravar($idtipo, $vrpercdesc, $parceiros, $servicos, $response, $request);
            
                if (!$validacao) {
                    Array_push($TipoException, "D");
                }
            }
            if($row["IDTIPOACRES"] && $row["VRPERCDESCACRES"] && $row["NRPARCNEGOCIOACRES"] && $row["CDSERVORCAACRES"]){
                $idtipo = $row["IDTIPOACRES"];
                $vrpercdesc = $row["VRPERCDESCACRES"];
                $parceiros = $row["NRPARCNEGOCIOACRES"];
                $servicos = $row["CDSERVORCAACRES"];
                $validacao = $this->gravar($idtipo, $vrpercdesc, $parceiros, $servicos, $response, $request);
                if (!$validacao) {
                    Array_push($TipoException, "A");
                }
            }
            if(count($TipoException)>0){
                if(count($TipoException) == 1){
                    if(in_array("A", $TipoException)){
                    throw new \Exception("A");
                    }
                    else 
                        if(in_array("D", $TipoException))
                        throw new \Exception("D");
                }else{
                    throw new \Exception("REGISTRO_DUPLICADO");
                }
            }
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
            
     }
     public function gravar($idtipo, $vrpercdesc, $parceiros, $servicos, $response, $request){
        try {
           
            $nrorg = $this->environment->getNrOrg();
            $columns = array("NRPARCNEGOCIO", "CDSERVORCA", "IDTIPO");
            $rows = array();
            
            foreach ($parceiros as $nrparcnegocio) {
                
                foreach ($servicos as $cdservorca) {
                    $row = array(
                        "__is_new"      => true,
                        "changed"       => true,
                        "NRSEQDESC"     => $this->newCode->getCodeByTableName("FCT_PERCDESCOPER", $nrorg, 1, 10, true),
                        "NRPARCNEGOCIO" => $nrparcnegocio,
                        "VRPERCDESC"    => $vrpercdesc,
                        "CDSERVORCA"    => $cdservorca,
                        "IDTIPO"        => $idtipo,
                        "NRORG"         => $nrorg,
                        "IDATIVO"       => "S"
                    );
                    
                    $rows[] = $row;
                    $_Not_Is_Repeted = $this->utilities->validateDuplicatedRecords($row, $this->dataSourceName, null, $columns);
                }
            }
            if($_Not_Is_Repeted){
                $novoRequest = new Request\DataSet(new DataSet($this->dataSourceName, $rows), "product#/crud/fct_percdescoper_widget/save", $request->getMethod(), $request->getUserId());
                $response = new Response();
                parent::save($novoRequest, $response);
                return $_Not_Is_Repeted;
            }else{
                return $_Not_Is_Repeted;
            }
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    /*public function saveCadastramentoAutomatico(Request\Row $request, Response $response){
        try {
            $row = $request->getRow();
           
            $idtipo = $row["IDTIPO"];
            $vrpercdesc = $row["VRPERCDESC"];
            $parceiros = $row["NRPARCNEGOCIO"];
            $servicos = $row["CDSERVORCA"];
            
            $nrorg = $this->environment->getNrOrg();
            $columns = array("NRPARCNEGOCIO", "CDSERVORCA", "IDTIPO");
            $rows = array();
            
            foreach ($parceiros as $nrparcnegocio) {
                
                foreach ($servicos as $cdservorca) {
                    $row = array(
                        "__is_new"      => true,
                        "changed"       => true,
                        "NRSEQDESC"     => $this->newCode->getCodeByTableName("FCT_PERCDESCOPER", $nrorg, 1, 10, true),
                        "NRPARCNEGOCIO" => $nrparcnegocio,
                        "VRPERCDESC"    => $vrpercdesc,
                        "CDSERVORCA"    => $cdservorca,
                        "IDTIPO"        => $idtipo,
                        "NRORG"         => $nrorg,
                        "IDATIVO"       => "S"
                    );
                    
                    $rows[] = $row;
                    $validacao = $this->utilities->validateDuplicatedRecords($row, $this->dataSourceName, null, $columns);
                    if ($validacao) {
                        throw new \Exception("REGISTRO_DUPLICADO");
                    }
                }
            }
            
            $novoRequest = new Request\DataSet(new DataSet($this->dataSourceName, $rows), "product#/crud/fct_percdescoper_widget/save", $request->getMethod(), $request->getUserId());
            $response = new Response();
            parent::save($novoRequest, $response);
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }*/

}

?>

