<?php
namespace Teknisa\SM\Service;

use Teknisa\Libs\Util\NewCode;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\Utilities;

class ConfirmaEnderecoService {
    
    protected $confirmaEnderecoFactory;
    
    public function __construct($confirmaEnderecoFactory){
        $this->confirmaEnderecoFactory = $confirmaEnderecoFactory;
    }
    
    public function confirmAddress($address){
        
        $messages       = '';
        $pais           = !empty($address['NMPAIS']) ? $address['NMPAIS'] : null;
        $cdpais         = $address['CDPAIS'];
        $paisSemAcento  = Utilities::removeAccents($pais);
        $paisConfirmado = $this->confirmaEnderecoFactory->searchCountry($pais, $paisSemAcento);
        $address['NMPAIS']      = $paisConfirmado ? $paisConfirmado : '';
        
        if(!empty($paisConfirmado)){
            $estado           = !empty($address['NMESTADO']) ? $address['NMESTADO'] : null;
            $sgestado         = !empty($address['SGESTADO']) ? $address['SGESTADO'] : null;
            $estadoSemAcento  = Utilities::removeAccents($estado);
            $estadoConfirmado = $this->confirmaEnderecoFactory->searchState($estado, $estadoSemAcento, $cdpais);
            $address['NMESTADO']    = $estadoConfirmado ? $estadoConfirmado : '';
        
            if(!empty($estadoConfirmado)){
                $municipio           = !empty($address['NMMUNICIPIO']) ? $address['NMMUNICIPIO'] : null;
                $cdmunicipio         = !empty($address['CDMUNICIPIO']) ? $address['CDMUNICIPIO'] : null;
                $municipioSemAcento  = Utilities::removeAccents($municipio);
                $municipioConfirmado = $this->confirmaEnderecoFactory->searchCity($municipio, $municipioSemAcento, $cdpais, $sgestado);
                $address['NMMUNICIPIO'] = $municipioConfirmado ? $municipioConfirmado : '';
                
                 if(!empty($municipioConfirmado)){
                    $bairro           = !empty($address['NMBAIRRO']) ? $address['NMBAIRRO'] : null;;
                    $bairroSemAcento  = Utilities::removeAccents($bairro);
                    $bairroConfirmado = $this->confirmaEnderecoFactory->searchNeigh($bairro, $bairroSemAcento, $cdpais, $sgestado, $cdmunicipio);
                    $address['NMBAIRRO']    = $bairroConfirmado ? $bairroConfirmado : '';
                    
                    if(empty($bairroConfirmado)){
                        $messages = 'Bairro não encontrado, favor inserir manualmente';
                    }
                }else{
                    $messages = 'Município e Bairro não encontrados, favor inserir manualmente';
                }
            }else{
                $messages = 'Estado não encontrados, favor inserir manualmente';
            }
        }else{
            $messages = 'País não encontrado, favor inserir manualmente.';
        }
        
        return array('ADDRESS' => $address, 'MESSAGES' => $messages);
        
    }

}